# coding=utf-8
#
# Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2021 All Rights Reserved
#
# Licensed under CLOUD LINUX LICENSE AGREEMENT
# http://cloudlinux.com/docs/LICENCE.TXT
#
import unittest
from collections import defaultdict
from lvestats.lib.chart import Renderer


class TestRenderer(unittest.TestCase):
    def test_get_faults_lines(self):
        data = defaultdict(list)
        data.update({
            'lio': [0.0, 0.0, 0.0, 0.0, 0.0],
            'lpmem': [0.0, 0.0, 0.0, 0.0, 0.0],
            'lnproc': [0.0, 0.0, 0.0, 0.0, 0.0],
            'lvmem': [0.0, 0.0, 0.0, 0.0, 0.0],
            'nprocf': [0.0, 0.0, 0.0, 0.0, 0.0],
            'cpuf': [1.0, 0.0, 10.0, 2.0, 0.0],
            'aiops': [0.0, 0.0, 0.0, 0.0, 0.0],
            'acpu': [2.5, 1.5, 23.5, 3.5, 3.5],
            'dbio': [0, 0, 0, 0, 0],
            'apmem': [0.0, 0.0, 0.0, 0.0, 0.0],
            'miops': [0.0, 0.0, 0.0, 0.0, 0.0],
            'dbcpu': [0, 0, 0, 0, 0],
            'pmemf': [0.0, 0.0, 0.0, 0.0, 0.0],
            'anproc': [0.0, 0.0, 0.0, 0.0, 0.0],
            'lep': [0.0, 0.0, 0.0, 0.0, 0.0],
            'avmem': [0.0, 0.0, 0.0, 0.0, 0.0],
            'iof': [0.0, 0.0, 0.0, 0.0, 0.0],
            'aep': [0.0, 0.0, 0.0, 0.0, 0.0],
            'iopsf': [0.0, 0.0, 0.0, 0.0, 0.0],
            'liops': [0.0, 0.0, 0.0, 0.0, 0.0],
            'aio': [0.0, 0.0, 0.0, 0.0, 0.0],
            'epf': [0.0, 0.0, 0.0, 0.0, 0.0],
            'vmemf': [0.0, 0.0, 0.0, 0.0, 0.0],
            'lcpu': [50.0, 50.0, 50.0, 50.0, 50.0]})
        dataset_dictionary = {
            'acpu': [[0., 2.5], [60., 1.5], [120., 23.5], [240., 3.5]],
            'lcpu': [(0.0, 50.0), (240.0, 50.0)]}
        faults = ('CPUf', 'aCPU', 'lCPU')
        x_values = [0.0, 60.0, 120.0, 180.0, 240.0]
        renderer = Renderer()
        result = renderer.get_faults_lines(data, dataset_dictionary, faults, x_values)
        self.assertEqual(result, [((0.0, 2.5), (0.0, 50.0)), ((120.0, 23.5), (120.0, 50.0)), ((180.0, 13.5), (180.0, 50.0))])
        dataset_dictionary['acpu'].pop(-1)
        result = renderer.get_faults_lines(data, dataset_dictionary, faults, x_values)
        self.assertEqual(result, [((0.0, 2.5), (0.0, 50.0)), ((120.0, 23.5), (120.0, 50.0)), ((180.0, 23.5), (180.0, 50.0))])