# coding=utf-8
#
# Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2023 All Rights Reserved
#
# Licensed under CLOUD LINUX LICENSE AGREEMENT
# http://cloudlinux.com/docs/LICENCE.TXT
#
import mock

from lvestats.plugins.generic.analyzers import LVEUsage
from lvestats.plugins.generic.dbsaver import DBSaver
from test.base.base_db_test import BaseDbTest


class TestDBSaver(BaseDbTest):
    def setUp(self):
        BaseDbTest.setUp(self)
        self.dbsaver = DBSaver()
        self.dbsaver.set_config(self.cfg)
        self.dbsaver.set_db_engine(self.engine)

    def test_assert_large_value_produces_exception(self):
        """Test that attempt for saving large value in LVEUsage statistics raises exception"""
        lveusage = LVEUsage(10)
        lveusage.memphy = 2**65
        with mock.patch('lvestats.plugins.generic.dbsaver.reboot_lock'), \
                self.assertRaises(OverflowError):
            self.dbsaver.execute({'LVE_VERSION': 10, 'lve_usage': {1: lveusage}})
