# coding=utf-8
#
# Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2021 All Rights Reserved
#
# Licensed under CLOUD LINUX LICENSE AGREEMENT
# http://cloudlinux.com/docs/LICENCE.TXT
#
import unittest
import tempfile
import os
import shutil

from lvestats.utils.dbmigrator.trash_cleaner import plugins_trash_cleaner


class PluginsCleaner(unittest.TestCase):

    def setUp(self):
        self.plugins_dir = tempfile.mkdtemp()
        # create good plugins
        open(os.path.join(self.plugins_dir, 'good_plugin.py'), 'w').close()
        open(os.path.join(self.plugins_dir, 'good_plugin.pyc'), 'w').close()
        os.symlink(os.path.join(self.plugins_dir, 'good_plugin.py'), os.path.join(self.plugins_dir, 'plugin_good_symlink.py'))
        # create bad plugins
        open(os.path.join(self.plugins_dir, 'plugin_trash.pyc'), 'w').close()
        os.symlink(tempfile.gettempdir() + '/no_such_plugin_df65rt.py',
                   os.path.join(self.plugins_dir, 'plugin_bad_symlink.py'))

    def tearDown(self):
        shutil.rmtree(self.plugins_dir)

    def test_plugins_trash_cleaner(self):
        plugins_trash_cleaner(self.plugins_dir)
        self.assertCountEqual(
            ['good_plugin.py', 'good_plugin.pyc', 'plugin_good_symlink.py'],
            os.listdir(self.plugins_dir))
