#!/usr/bin/python
# coding=utf-8

import mock
from unittest import TestCase
from lvestats.lib.commons.users_manager import UsersInfoManager

__author__ = "Aleksandr Shyshatsky"


class TestUsersManager(TestCase):
    def setUp(self):
        self.users_manager = UsersInfoManager()

    def test_build_cache_for_admin(self):
        def cpinfo(cplogin=None, keyls=None, search_sys_users=False):
            return [('user1', 'reseller1', 'user1.com'), ('user2', 'reseller1', 'user2.com')]

        with mock.patch('lvestats.lib.commons.users_manager.cpapi.cpinfo', side_effect=cpinfo):
            self.users_manager.build_users_cache(None)
        self.assertEqual(self.users_manager.get_domain('user1'), 'user1.com')
        self.assertEqual(self.users_manager.get_reseller('user1'), 'reseller1')

    def test_build_cache_for_reseller(self):
        reseller_domains = dict(user1='user1.com', user2='user2.com')
        with mock.patch('lvestats.lib.commons.users_manager.func.get_reseller_domains',
                        return_value=reseller_domains):
            self.users_manager.build_users_cache('reseller')
            self.assertEqual(self.users_manager.get_domain('user1'), 'user1.com')
            self.assertEqual(self.users_manager.get_reseller('user1'), 'reseller')
