# coding=utf-8
#
# Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2021 All Rights Reserved
#
# Licensed under CLOUD LINUX LICENSE AGREEMENT
# http://cloudlinux.com/docs/LICENCE.TXT
#
import os
import shutil
import sys
import unittest
from test.helpers import import_fail

from test.base.base_db_test import BaseDbTest

BACKUP_PATH = os.path.join(os.path.dirname(__file__), "dbmigrate_backup")


class TestDbmigrateBackup(BaseDbTest):
    def setUp(self):
        import lvestats.utils.dbmigrator
        shutil.copytree(os.path.dirname(lvestats.utils.dbmigrator.__file__), BACKUP_PATH)
        sys.path.append(BACKUP_PATH)

    def tearDown(self):
        shutil.rmtree(BACKUP_PATH)
        sys.path.remove(BACKUP_PATH)

    def test_backup_execution(self):
        # make sure that dbmigrate can work outside of lvestats package
        # mocking import from lvestats package so that any import would fail
        with import_fail("lvestats.utils.dbmigrator"):
            # pylint:disable=import-error
            import dbmigrate_backup.dbmigrate as dbmigrate
            dbmigrate.main(self.cfg, self.engine)
