# coding=utf-8
#
# Copyright © Cloud Linux GmbH & Cloud Linux Software, Inc 2010-2021 All Rights Reserved
#
# Licensed under CLOUD LINUX LICENSE AGREEMENT
# http://cloudlinux.com/docs/LICENCE.TXT
#
import unittest

import ddt

from lvestats.utils.v1import import get_connection_string, V1_SQLITE_DB, V1_KEY


@ddt.ddt
class TestV1Import(unittest.TestCase):
    @ddt.data([{'db_type': 'sqlite'}, V1_SQLITE_DB],
              [{'db_type': 'mysql', 'connect_string': 'host:database:user:password'},
               'mysql://user:password@host/database'],
              [{'db_type': 'postgresql', 'connect_string': 'host:database:user:password'},
               'postgresql://user:password@host/database'])
    @ddt.unpack
    def test_get_connection_string(self, config, connect_string):
        get_connection_string(config)
        self.assertEqual(config[V1_KEY], connect_string)

